#include <stdio.h>
#include <ctype.h>

void fn1(void)
{
	printf("This is function 1\n");
}

void fn2(void)
{
	printf("You got it!\n");
	exit(0);
}

void dump_mem(char *ptr,int count)
{
	int	i, ch;
	char	*p;

	for (i = 0, p = ptr; i < count; i++) {
		printf(" %02x",0xff & *p++);
		if ((i & 0xf) == 0xf) putchar('\n');
	}
	putchar('\n');
	for (i = 0, p = ptr; i < count; i++) {
		ch = 0xff & *p++;
		printf(" %c",(isprint(ch)) ? ch : '?');
		if ((i & 0xf) == 0xf) putchar('\n');
	}
	putchar('\n');
}

void target(void)
{
	char	buf[16];

	dump_mem(buf,0x100);
	printf("buf: %#lx\n",(long) buf);

	printf("Input text: ");
	if (!gets(buf)) {
		printf("Got EOF\n");
		exit(0);
	}
	dump_mem(buf,0x100);
	printf("Got: %s\n",buf);
	fn1();
}

void target_caller(void)
{
	printf("entered target_caller\n");
	target();
	printf("leaving target_caller\n");
}

int main(void)
{
	printf("main: %#lx\n",(long) main);
	printf("gets: %#lx\n",(long) gets);
	printf("fn1 : %#lx\n",(long) fn1);
	printf("fn2 : %#lx\n",(long) fn2);
	target_caller();
	printf("target returned\n");
	exit(0);
	fn2();
	return 0;
}
